#ifndef WIN32
#include <sys/socket.h> 								/* for bind(3), socket(3), etc. */
#include <sys/un.h> 										/* for sockaddr_un */
#include <sys/time.h> 									// timeval
#include <arpa/inet.h>									/* for Internet networking stuff */
#include <unistd.h> 										/* for fork(2), setsid(2), unlink(2) */
#include <cerrno>
#include <cstdlib>											/* for exit(2) */
#include <fcntl.h>
#include <pthread.h>
#include <sys/types.h>
#include <signal.h>


#define INVALID_SOCKET -1
typedef int SOCKET;
#include <sys/un.h>
#endif

#ifndef PJL_NO_NAMESPACES
using namespace std;
#endif
#include <windows.h>
#include <process.h>
#include <conio.h>
#include <tchar.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include "service.h"

void		serviceStart( int argc, char **argv );
void		serviceStop();
HANDLE	hServerStopEvent = NULL;
bool		finishServiceRequest=false;
int serviceState = 0;


int main( int argc, char **argv )
{


SERVICE_TABLE_ENTRY dispatchTable[]={{ TEXT(SERVICENAME), (LPSERVICE_MAIN_FUNCTION)serviceMain },
					{ NULL, NULL }};

			if (argc>1)
			{
				if (!strcmp(argv[1],"-install"))		 //install service - win32
						{
           						installService();
	 						exit(0);
						}
				else if (!strcmp(argv[1],"-remove")) //remove srevice - win32
						{
							removeService();
							exit(0);
						}
              		 }
			 else
				{
//////////////////////////////////////////////////////////////////
//							Start service
//////////////////////////////////////////////////////////////////
 			if (!StartServiceCtrlDispatcher(dispatchTable))
 			    AddToMessageLog( TEXT("StartServiceCtrlDispatcher failed."),EVENTLOG_ERROR_TYPE );
				}
}



/////////////////////////////////////////////////////////////////////
//
//			Service start
//
////////////////////////////////////////////////////////////////////
void serviceStart( int argc, char **argv )
{
HANDLE	hEvents[1] = {NULL};
		ReportStatusToSCMgr( SERVICE_START_PENDING, NO_ERROR, 3000);
		hServerStopEvent = CreateEvent( NULL, TRUE, FALSE, NULL);
		hEvents[0] = hServerStopEvent;
		ReportStatusToSCMgr( SERVICE_START_PENDING, NO_ERROR, 20000);
                //* Put your postmaster startup code hier
        	//Service is now started , we report it to event log
		ReportStatusToSCMgr( SERVICE_RUNNING, NO_ERROR, 0);
}






/////////////////////////////////////////////////
//
// Stop it know
//
////////////////////////////////////////////////
void serviceStop()
{
  bool finished = false;
  ReportStatusToSCMgr( SERVICE_STOP_PENDING, NO_ERROR, 50000 );
#endif
		 while(!finished)
		 {
			 finishServiceRequest=true;
			 if (!WeShouldWaitForSomething)
			 {
				finished = true;
			 }
			 else
                         //we should wait, so we do it and report to event log
                         ReportStatusToSCMgr( SERVICE_STOP_PENDING, NO_ERROR, 5000 );

		 }
			// We will stop know
			SetEvent(hServerStopEvent);
			exit(0);
}


